;------------------------------------------------------------------
;procedura gwna obliczajca spadki cinie elementw jednego typu
(defun obliczPa#w ( sciezkaPlik#w plik#w jm#w jm_wsp#w wszystkieKierPa#w listaDoPa#w / 
                    obi#w rozmiar#w kierunki#w kiery#w i#w j#w zwrot#w zwrotObi#w
		    figura#w akcesoria#w 
		    daneAd1-d3#w daneAd1-d2#w daneBd3-d2#w daneBd1-d2#w daneDd3-d1=d2#w
		    daneCd1-d3#w 
		    daneAd1-d3_050#w daneAd1-d2_050#w daneBd3-d2_050#w daneBd1-d2_050#w
		    daneAd1-d3_075#w daneAd1-d2_075#w daneBd3-d2_075#w daneBd1-d2_075#w
		    daneAd1-d3_100#w daneAd1-d2_100#w daneBd3-d2_100#w daneBd1-d2_100#w ) 

;jm#w       "_cm#w"
;jm_wsp#w   "0.1"
;zmienna przenoszca razem wykryte kierunki we wszystkich obiektach tego typu
;  wszystkieKierPa#w np.(("P1>P3" "P1>P2")("P1>P2" "P1>P3"))
;po rozpakowaniu listy listaDoPa#w tworzy z jej rekordu:
;  obi#w      
;  rozmiar#w  ("d1mm" "150") ("d3mm" "80") ("Lmm" "140") ("Hmm" "87") ("kgTCPL" "0.5") 
;  kierunki#w (("P1" "d1mm" "200.00" (144.929 64.6729 0.0) "P3" "d3mm" "100.00" (151.929 73.3729 0.0)) 
;              ("P1" "d1mm" "200.00" (144.929 64.6729 0.0) "P2" "d1mm" "100.00" (158.929 64.6729 0.0)))
;  kiery#w    (("P3>P1" "P2>P1") ("P2>P1" "P3>P1")) - ju po podwojeniu-odwrceniu poniej
;  dalsze nie w kadym elemencie potrzebne:
;  figura#w   "12"
;  akcesoria#w (("" "")) lub (("WentyleSpiroRGS_akcesoria" "2")("WentyleSpiroRGS_lamelki" "1")
;                             ("WentyleSpiroRGS_przepustnica" "0"))  


;zaadowanie danych pod odpowiednie zmienne
(foreach i#w wszystkieKierPa#w
(cond

;Ad1-d3
((and (not daneAd1-d3#w)
(or (equal i#w '("P1>P3" "P1>P2")) (equal i#w '("P2>P3" "P2>P1")) ))
     (progn 
		(load (strcat sciezkaPlik#w plik#w "_Ad1-d3_050.lsp"))
		(setq daneAd1-d3_050#w (obliczPa1#w)) 
		(load (strcat sciezkaPlik#w plik#w "_Ad1-d3_075.lsp"))
		(setq daneAd1-d3_075#w (obliczPa1#w)) 
		(load (strcat sciezkaPlik#w plik#w "_Ad1-d3_100.lsp"))
		(setq daneAd1-d3_100#w (obliczPa1#w)) 
		))
;Ad1-d2
((and (not daneAd1-d2#w)
(or (equal i#w '("P1>P2" "P1>P3")) (equal i#w '("P2>P1" "P2>P3")) ))
     (progn 
		(load (strcat sciezkaPlik#w plik#w "_Ad1-d2_050.lsp"))
		(setq daneAd1-d2_050#w (obliczPa1#w)) 
		(load (strcat sciezkaPlik#w plik#w "_Ad1-d2_075.lsp"))
		(setq daneAd1-d2_075#w (obliczPa1#w)) 
		(load (strcat sciezkaPlik#w plik#w "_Ad1-d2_100.lsp"))
		(setq daneAd1-d2_100#w (obliczPa1#w))
		))
;Bd3-d2
((and (not daneBd3-d2#w)
(or (equal i#w '("P3>P2" "P1>P2")) (equal i#w '("P3>P1" "P2>P1")) ))
     (progn 
		(load (strcat sciezkaPlik#w plik#w "_Bd3-d2_050.lsp"))
		(setq daneBd3-d2_050#w (obliczPa1#w)) 
		(load (strcat sciezkaPlik#w plik#w "_Bd3-d2_075.lsp"))
		(setq daneBd3-d2_075#w (obliczPa1#w)) 
		(load (strcat sciezkaPlik#w plik#w "_Bd3-d2_100.lsp"))
		(setq daneBd3-d2_100#w (obliczPa1#w)) 
		))
;Bd1-d2
((and (not daneBd1-d2#w)
(or (equal i#w '("P1>P2" "P3>P2")) (equal i#w '("P2>P1" "P3>P1")) ))
     (progn 
		(load (strcat sciezkaPlik#w plik#w "_Bd1-d2_050.lsp"))
		(setq daneBd1-d2_050#w (obliczPa1#w)) 
		(load (strcat sciezkaPlik#w plik#w "_Bd1-d2_075.lsp"))
		(setq daneBd1-d2_075#w (obliczPa1#w))
		(load (strcat sciezkaPlik#w plik#w "_Bd1-d2_100.lsp"))
		(setq daneBd1-d2_100#w (obliczPa1#w))
		))

;Dd3-d1=d2
((and (not daneDd3-d1=d2#w)
(or (equal i#w '("P3>P1" "P3>P2")) (equal i#w '("P3>P2" "P3>P1")) ))
     (progn (load (strcat sciezkaPlik#w plik#w "_Dd3-d1=d2.lsp"))
            (setq daneDd3-d1=d2#w (obliczPa1#w)) ))
;Cd1-d3
((and (not daneCd1-d3#w)
(or (equal i#w '("P1>P3" "P2>P3")) (equal i#w '("P2>P3" "P1>P3")) ))
     (progn (load (strcat sciezkaPlik#w plik#w "_Cd1-d3.lsp"))
            (setq daneCd1-d3#w (obliczPa1#w)) ))

));cond/foreach



;obliczenie spadku cinienia na elemencie
(setq zwrot#w '())
 
(foreach i#w listaDoPa#w
(progn  (setq obi#w (handent (car i#w))
	      rozmiar#w  (cadr i#w) 
              kiery#w    (caddr i#w)
              kierunki#w (cadddr i#w) )

;kiery#w - podwojone-odwrcone aby liczy dPa pod warunkiem innego
;te dla drugiego kierunku, trzeciego itd.
(setq p#w      kiery#w
      kiery#w (list kiery#w))
(repeat (- (length p#w) 1) 
        (setq kiery#w (append kiery#w (list
	              (append (list (car (reverse p#w))) (reverse (cdr (reverse p#w))))
))));list/append/setq/repeat


	;UWAGA - dane#w tu wyjtkowo <nil w czterech aktywnych przypadkach> okrelane bdzie
	;        w procedurze podrzdnej na bazie daneAd1-d3_075#w, daneAd1-d3_100#w ...

	(setq zwrotObi#w '())
	(foreach j#w kiery#w
	(progn

	(cond
	;Ad1-d3
	((or (equal j#w '("P1>P3" "P1>P2")) (equal j#w '("P2>P3" "P2>P1")) )
	     (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		               (liczyPa#w j#w rozmiar#w kierunki#w daneAd1-d3#w) )))))
	;Ad1-d2
	((or (equal j#w '("P1>P2" "P1>P3")) (equal j#w '("P2>P1" "P2>P3")) )
	     (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		               (liczyPa#w j#w rozmiar#w kierunki#w daneAd1-d2#w) )))))
	;Bd3-d2
	((or (equal j#w '("P3>P2" "P1>P2")) (equal j#w '("P3>P1" "P2>P1")) )
	     (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		               (liczyPa#w j#w rozmiar#w kierunki#w daneBd3-d2#w) )))))
	;Bd1-d2
	((or (equal j#w '("P1>P2" "P3>P2")) (equal j#w '("P2>P1" "P3>P1")) )
	     (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		               (liczyPa#w j#w rozmiar#w kierunki#w daneBd1-d2#w) )))))
	;Dd3-d1=d2
	((or (equal j#w '("P3>P1" "P3>P2")) (equal j#w '("P3>P2" "P3>P1")) )
	     (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		               (liczyPa#w j#w rozmiar#w kierunki#w daneDd3-d1=d2#w) )))))
	;Cd1-d3
	((or (equal j#w '("P1>P3" "P2>P3")) (equal j#w '("P2>P3" "P1>P3")))
	     (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		               (liczyPa#w j#w rozmiar#w kierunki#w daneCd1-d3#w) )))))
	);cond

	));progn/foreach j#w
        (if zwrotObi#w (setq zwrotObi#w (append (list obi#w) zwrotObi#w)))

(if zwrotObi#w (setq zwrot#w (append zwrot#w (list zwrotObi#w))))
));progn/foreach i#w

;zwrot#w ((<Entity name: 2792a90> (("P1>P3" "P2>P3") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P3" "P1>P3") "35" "0;Przekroczony zasig danych o spadkach!")) 
;         (<Entity name: 2792cc8> (("P3>P1" "P2>P1") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P1" "P3>P1") "35" "0;Przekroczony zasig danych o spadkach!")))
zwrot#w
);defun











;podprocedura porednia obliczeniowa spadkw cinie jednego kierunku jednego elementu
(defun liczyPa#w ( i#w rozmiar#w kierunki#w dane#w / a#w b#w a1#w a2#w b1#w  dzeta#w reszta#w ro#w dPa#w 
                   p#w pp#w p1#w p2#w error#w text#w czolo#w
                   kolejnosc#w d#w d1#w f#w f1#w f0#w wyd#w wyd1#w v#w v1#w
		   kierTu#w j#w Vten#w Vxos#w zwrot#w wspPa#w wyd12#w f2dof1#w min#w minX#w j#w)


;i#w ("P3>P1" "P2>P1")
;rozmiar#w  (("A mm" "300") ("B mm" "300") ("A1 mm" "200") ("A2 mm" "100") ("C mm" "300") ("D mm" "400") ("E mm" "500"))
;kierunki#w (("P3" "a2xbmm" "200" (326.032 559.799 0.0) "P1" "axbmm" "600" (296.032 524.799 0.0)) 
;("P2" "a1xbmm" "400" (346.032 519.799 0.0) "P1" "axbmm" "600" (296.032 ;524.799 0.0)))
;dane#w (("0.25" "0.1" "-3.12") ("0.25" "0.2" "0.00") ...)

(setq p#w (car i#w) p1#w (substr p#w 1 2) p2#w (substr p#w 4 2))
(foreach j#w kierunki#w
(if (and (= (nth 0 j#w) p1#w) (= (nth 4 j#w) p2#w))(setq kierTu#w j#w)))

;rozszyfrowanie wymiaru i obliczenie przekroju
;oraz kolejnosc#w '("1" "2") lub '("2" "1") prdkosci z kierunku w danych z wykresu 
(cond
;Ad1-d3 (F3/F1, wyd3/wyd1, DPa[Pa])
((or (equal i#w '("P1>P3" "P1>P2")) (equal i#w '("P2>P3" "P2>P1")) )
     (progn     ;wymiar>przekrj
		(setq a2#w (atof (cadr (assoc "C mm" rozmiar#w)))
		      b#w  (atof (cadr (assoc "B mm" rozmiar#w))) 
		      a#w  (atof (cadr (assoc "A mm" rozmiar#w)))
		      a1#w (atof (cadr (assoc "D mm" rozmiar#w))) )
		(if (> a1#w a#w) (setq p#w a#w  a#w a1#w  a1#w p#w))
		(setq a#w   (/ a#w 1000.0) ;[m]
		      b#w   (/ b#w 1000.0) ;[m]
		      a1#w  (/ a1#w 1000.0) ;[m]
		      a2#w  (/ a2#w 1000.0) ;[m]

		      f#w  (* a#w  b#w)  ;[m2]
		      f1#w (* a2#w b#w)  ;[m2]
		      wyd#w  (/ (atof (nth 2 kierTu#w)) 3600)
		      wyd1#w (/ (atof (nth 6 kierTu#w)) 3600)  ;[m3/s]
		      v#w  (/ wyd#w f#w)	;[m/s]
		      v1#w (/ wyd1#w f1#w))	;[m/s]

		(setq 	f2dof1#w (/ (* a1#w b#w) (* a#w  b#w)) 
			min#w 1000000.0)
		(foreach j#w '(1.00 0.75 0.50) 
		(if (< (abs (- f2dof1#w j#w)) min#w)(setq min#w (abs (- f2dof1#w j#w)) minX#w j#w) ))
		(cond
		((= minX#w 1.00) (setq dane#w daneAd1-d3_100#w))
		((= minX#w 0.75) (setq dane#w daneAd1-d3_075#w))		
		((= minX#w 0.50) (setq dane#w daneAd1-d3_050#w))		
		(T		 (setq dane#w daneAd1-d3_100#w))
		);cond

		(setq text#w "0;Trjn.odejcie")
		(setq zwrot#w (LiczyPa_odczytDPa#w  (rtos (/ f1#w f#w) 2 12)
						    (rtos (/ wyd1#w wyd#w) 2 12)
						    dane#w) )
	;zamiana dzeta w zwrot#w na dPa#w
	(setq dzeta#w   (car zwrot#w)
	      reszta#w (cadr zwrot#w))
	(if (/= dzeta#w "")(progn 
			   (setq ro#w  1.2 ;[kg/m3] gsto powietrza
				       dPa#w  (* (atof dzeta#w) (/ (* ro#w (* v1#w v1#w)) 2))) ;[Pa]

      			   ;tu korekcja szacunkowa spadku na odejciu przypadku trjnik-rozejcie
			   (setq dPa#w (+ dPa#w (* 0.5 (abs dPa#w))))

			   (setq zwrot#w (list  (rtos dPa#w 2 2) reszta#w))
			   ));progn/if
     ));progn+

;Ad1-d2(F3/F1, wyd2/wyd1, DPa[Pa])
((or (equal i#w '("P1>P2" "P1>P3")) (equal i#w '("P2>P1" "P2>P3")) )
     (progn     ;wymiar>przekrj
		(setq a2#w (atof (cadr (assoc "C mm" rozmiar#w)))
		      b#w  (atof (cadr (assoc "B mm" rozmiar#w))) 
		      a#w  (atof (cadr (assoc "A mm" rozmiar#w)))
		      a1#w (atof (cadr (assoc "D mm" rozmiar#w))) )
		(if (> a1#w a#w) (setq p#w a#w  a#w a1#w  a1#w p#w))
		(setq a#w   (/ a#w 1000.0) ;[m]
		      b#w   (/ b#w 1000.0) ;[m]
		      a1#w  (/ a1#w 1000.0) ;[m]
		      a2#w  (/ a2#w 1000.0) ;[m]

		      f#w  (* a#w  b#w)  ;[m2]
		      f1#w (* a1#w b#w)   ;[m2]
		      f0#w (* a2#w b#w)  ;[m2]

		      wyd#w  (/ (atof (nth 2 kierTu#w)) 3600)
		      wyd1#w (/ (atof (nth 6 kierTu#w)) 3600)  ;[m3/s]
		      v#w  (/ wyd#w f#w)	;[m/s]
		      v1#w (/ wyd1#w f1#w))	;[m/s]

		(setq 	f2dof1#w (/ (* a1#w b#w) (* a#w  b#w)) 
			min#w 1000000.0)
		(foreach j#w '(1.00 0.75 0.50) 
		(if (< (abs (- f2dof1#w j#w)) min#w)(setq min#w (abs (- f2dof1#w j#w)) minX#w j#w) ))
		(cond
		((= minX#w 1.00) (setq dane#w daneAd1-d2_100#w))
		((= minX#w 0.75) (setq dane#w daneAd1-d2_075#w))		
		((= minX#w 0.50) (setq dane#w daneAd1-d2_050#w))		
		(T		 (setq dane#w daneAd1-d2_100#w))
		);cond

		(setq text#w "0;Trjn.przelot")
		(setq zwrot#w (LiczyPa_odczytDPa#w  (rtos (/ f0#w f#w) 2 12)
						    (rtos (/ wyd1#w wyd#w) 2 12)
						    dane#w) )
	;zamiana dzeta w zwrot#w na dPa#w
	(setq dzeta#w   (car zwrot#w)
	      reszta#w (cadr zwrot#w))
	(if (/= dzeta#w "")(progn 
			   (setq ro#w  1.2 ;[kg/m3] gsto powietrza
				       dPa#w  (* (atof dzeta#w) (/ (* ro#w (* v1#w v1#w)) 2))) ;[Pa]

      			   ;tu korekcja szacunkowa spadku na przelocie przypadku trjnik-rozejcie
			   (if (= dPa#w 0.0) (setq dPa#w 1.0))
			   (cond ((< dPa#w 4.0) (setq dPa#w (+ dPa#w (* 5.0 (abs dPa#w)))))
			         (T 	        (setq dPa#w (+ dPa#w (* 2.0 (abs dPa#w))))) )

			   (setq zwrot#w (list  (rtos dPa#w 2 2) reszta#w))
			   ));progn/if
     ));progn+


;Bd3-d2 (F3/F2, wyd3/wyd2, DPa[Pa])
((or (equal i#w '("P3>P2" "P1>P2")) (equal i#w '("P3>P1" "P2>P1")) )
     (progn     ;wymiar>przekrj
		(setq a2#w (atof (cadr (assoc "C mm" rozmiar#w)))
		      b#w  (atof (cadr (assoc "B mm" rozmiar#w))) 
		      a#w  (atof (cadr (assoc "A mm" rozmiar#w)))
		      a1#w (atof (cadr (assoc "D mm" rozmiar#w))) )
		(if (> a1#w a#w) (setq p#w a#w  a#w a1#w  a1#w p#w))
		(setq a#w   (/ a#w 1000.0) ;[m]
		      b#w   (/ b#w 1000.0) ;[m]
		      a1#w  (/ a1#w 1000.0) ;[m]
		      a2#w  (/ a2#w 1000.0) ;[m]

		      f#w  (* a2#w  b#w)  ;[m2]
		      f1#w (* a#w b#w)    ;[m2]
		      wyd#w  (/ (atof (nth 2 kierTu#w)) 3600)
		      wyd1#w (/ (atof (nth 6 kierTu#w)) 3600)  ;[m3/s]
		      v#w  (/ wyd#w f#w)	;[m/s]
		      v1#w (/ wyd1#w f1#w))	;[m/s]

		(setq 	f2dof1#w (/ (* a1#w b#w) (* a#w  b#w)) 
			min#w 1000000.0)
		(foreach j#w '(1.00 0.75 0.50) 
		(if (< (abs (- f2dof1#w j#w)) min#w)(setq min#w (abs (- f2dof1#w j#w)) minX#w j#w) ))
		(cond
		((= minX#w 1.00) (setq dane#w daneBd3-d2_100#w))
		((= minX#w 0.75) (setq dane#w daneBd3-d2_075#w))		
		((= minX#w 0.50) (setq dane#w daneBd3-d2_050#w))		
		(T		 (setq dane#w daneBd3-d2_100#w))
		);cond

		(setq text#w "0;Trjn.dolot")
		(setq zwrot#w (LiczyPa_odczytDPa#w  (rtos (/ f#w f1#w) 2 12)
						    (rtos (/ wyd#w wyd1#w) 2 12)
						    dane#w) )	
	
	;zamiana dzeta w zwrot#w na dPa#w
	(setq dzeta#w   (car zwrot#w)
	      reszta#w (cadr zwrot#w))	
	(if (/= dzeta#w "")(progn 
			   (setq ro#w  1.2 ;[kg/m3] gsto powietrza
				       dPa#w  (* (atof dzeta#w) (/ (* ro#w (* v#w v#w)) 2))) ;[Pa]

      			   ;tu korekcja szacunkowa spadku na dolocie przypadku trjnik-zejcie
			   (setq dPa#w (+ dPa#w (* 0.5 (abs dPa#w))))

			   (setq zwrot#w (list  (rtos dPa#w 2 2) reszta#w))
					   ));progn/if
     ));progn+


;Bd1-d2 (F3/F2, wyd1/wyd2, DPa[Pa])
((or (equal i#w '("P1>P2" "P3>P2")) (equal i#w '("P2>P1" "P3>P1")) )
     (progn     ;wymiar>przekrj
		(setq a2#w (atof (cadr (assoc "C mm" rozmiar#w)))
		      b#w  (atof (cadr (assoc "B mm" rozmiar#w))) 
		      a#w  (atof (cadr (assoc "A mm" rozmiar#w)))
		      a1#w (atof (cadr (assoc "D mm" rozmiar#w))) )
		(if (> a1#w a#w) (setq p#w a#w  a#w a1#w  a1#w p#w))
		(setq a#w   (/ a#w 1000.0) ;[m]
		      b#w   (/ b#w 1000.0) ;[m]
		      a1#w  (/ a1#w 1000.0) ;[m]
		      a2#w  (/ a2#w 1000.0) ;[m]

		      f#w  (* a#w  b#w) ;[m2]
		      f1#w (* a1#w b#w)  ;[m2]
		      f0#w (* a2#w b#w)  ;[m2]

		      wyd#w  (/ (atof (nth 2 kierTu#w)) 3600)
		      wyd1#w (/ (atof (nth 6 kierTu#w)) 3600)  ;[m3/s]
		      v#w  (/ wyd#w f1#w)	;[m/s]
		      v1#w (/ wyd1#w f#w))	;[m/s]



		(setq 	f2dof1#w (/ (* a1#w b#w) (* a#w  b#w)) 
			min#w 1000000.0)
		(foreach j#w '(1.00 0.75 0.50) 
		(if (< (abs (- f2dof1#w j#w)) min#w)(setq min#w (abs (- f2dof1#w j#w)) minX#w j#w) ))
		(cond
		((= minX#w 1.00) (setq dane#w daneBd1-d2_100#w))
		((= minX#w 0.75) (setq dane#w daneBd1-d2_075#w))		
		((= minX#w 0.50) (setq dane#w daneBd1-d2_050#w))		
		(T		 (setq dane#w daneBd1-d2_100#w))
		);cond

		(setq text#w "0;Trjn.przelot")
		(setq zwrot#w (LiczyPa_odczytDPa#w  (rtos (/ f0#w f#w) 2 12)
						    (rtos (/ wyd#w wyd1#w) 2 12)
						    dane#w) )	
	
	;zamiana dzeta w zwrot#w na dPa#w
	(setq dzeta#w   (car zwrot#w)
	      reszta#w (cadr zwrot#w))
	(if (/= dzeta#w "")(progn 
			   (setq ro#w  1.2 ;[kg/m3] gsto powietrza
				       dPa#w  (* (atof dzeta#w) (/ (* ro#w (* v#w v#w)) 2))) ;[Pa]

      			   ;tu korekcja szacunkowa spadku na przelocie przypadku trjnik-zejcie
			   (setq dPa#w (+ dPa#w (* 0.5 (abs dPa#w))))

			  (setq zwrot#w (list  (rtos dPa#w 2 2) reszta#w))
				   ));progn/if
     ));progn+



;Dd3-d1=d2(F1/F3lubF2/F3, W1/W3lubW2/W3, DPa[Pa]) - ale zrobi, e nie koniecznie d1=d2
((or (equal i#w '("P3>P1" "P3>P2")) (equal i#w '("P3>P2" "P3>P1")) )
     (progn

	(setq zwrot#w '("" "0;Kierunek bez danych"))

     ));progn+


;Z Idelchika
;Cd1-d3(zawsze F1/F3lubF2/F3, W1/W3lubW2/W3, DPa[Pa])
((or (equal i#w '("P1>P3" "P2>P3")) (equal i#w '("P2>P3" "P1>P3")) )
     (progn

	(setq zwrot#w '("" "0;Kierunek bez danych"))

     ));progn+


);cond

(if (and text#w (= (cadr zwrot#w) "")) (setq zwrot#w (list (car zwrot#w) text#w)))
(if (and error#w (= (cadr zwrot#w) "")) (setq zwrot#w (list (car zwrot#w) text#w)))

zwrot#w   ;'("35" "Trjn.przelot") lub np. '("" "0;Przekroczony zakres na wykresie spadkw ci.") 
);defun 





